/**********************************************************************
 * tabla-de-struct.c
 *
 * Se pretende mostrar como descomponer el código de este fichero en 
 * varios ficheros .c y sus correspondientes .h
 * principal.c <-- contiene sólo la función main
 * rellena.c   <-- contiene la definición de la función rellena
 * imprime.c   <-- contiene la definición de la función imprime
 * rellena.h   <-- contiene la def. de tipos y el prototipo de rellena
 * imprime.h   <-- contiene la def. de tipos y el prototipo de imprime 
 * 
 ***********************************************************************/

#include <stdio.h>

#define TAM 5

// Definimos un nuevo tipo de datos: ARTICULO
typedef struct articulo {
  char titulo[20];
  int paginas;
} ARTICULO;

// Definimos un nuevo tipo de datos: TABLA
typedef ARTICULO TABLA[TAM];

// Prototipos de nuestras funciones
void rellena(TABLA tabla);
void imprime(TABLA tabla);
// Hasta aquí se descompone en los .h

// Desde aquí...
int main()
{
  TABLA articulos;

  printf("\n\n");

  printf("Vamos a rellenar la tabla: \n");
  rellena(articulos);

  printf("Vamos a imprimir la tabla: \n");
  imprime(articulos);

  printf("\n\n");

  return 0;
}
//... hasta aquí irá a principal.c

// Definición de la función rellena
void rellena(TABLA tabla)
{
  int i=0;
  for(i=0;i<TAM;i++)
    {
      printf("\nIntroduce el título: ");
      scanf("%s", tabla[i].titulo);
      printf("Introduce el núm. de páginas: ");
      scanf("%d", &(tabla[i].paginas));
    }
  printf("\n--FIN DE INTRODUCCIÓN DE DATOS--\n\n");
}
// La función rellena irá en rellena.c

// Definición de la función imprime
void imprime(TABLA tabla)
{
  int i=0;
  for(i=0;i<TAM;i++)
    {
      printf("\nEl título del libro %d es: %s.\n",i, tabla[i].titulo);
      printf("El núm. de páginas del libro %d es: %d.\n", i, tabla[i].paginas);
    }
  printf("\n--FIN DE LA IMPRESIÓN DE DATOS--\n\n");
}
// La función imprime irá en imprime.c
